#ifndef _INTR_H
#define _INTR_H

// headers we depend upon
//
#include "..\types\types.h"

#ifdef __cplusplus
extern "C" {
#endif



// pointer to a function that accepts
// a user-defined pointer and all registers
// as arguments and returns an integer
//
typedef int (*ifp)( void *parms, Bit32 ebp, Bit32 edi, Bit32 esi,
    Bit32 ds, Bit32 es, Bit32 edx, Bit32 ecx, Bit32 ebx, Bit32 eax,
    Bit32 eip, Bit32 cs, Bit32 flags );

void setvect( Bit8 vector, Bit48 pointer );
void setvect_real( Bit8 vector, Bit32 pointer );
Bit48 getvect( Bit8 vector );
Bit32 getvect_real( Bit8 vector );
vfp make_thunk( ifp proc, Bit48 *chainAddr, void *parms );



#ifdef __cplusplus
}
#endif

#endif  // not included yet
