#  1230, Thu 20 May 99
#
#  Makefile for 32-bit (flat memory model) BGP
#

DEBUG =     D    # E to enable, D to disable
PROCESSOR = 5    # 3 for 386..Pentium, 5 for Pentium only
CC = bcc32 -WX   # Flat memory model

!if '$(DEBUG)'=='E'
CDEBUG = -v
ADEBUG = -zi
TEXTDEBUG = enabled
!elif '$(DEBUG)'=='D'
TEXTDEBUG = disabled
!else
!error  DEBUG must be set to either E or D
!endif
!if '$(PROCESSOR)'=='3'
PROC = -3 -DCLK_86
!elif '$(PROCESSOR)'=='5'
PROC = -5
!else
!error  PROCESSOR must be set to either 3 or 5
!endif

CFLAGS = $(PROC) -w-par -a- -Otabeiv -O -Z  $(CDEBUG) -DNETRAMET=1

SRC = ..\integrat
LIBNAME = bgplib

.c.obj:
    $(CC) $(CFLAGS) -c $*.c
    tlib $(LIBNAME) -+$@

BGPOBJS = readbgp.obj subnet.obj

all: $(BGPOBJS)
        echo done

readbgp.obj: $(SRC)\readbgp.c
subnet.obj:  $(SRC)\subnet.c $(SRC)\subnet.h \
             $(SRC)\subnetp.h $(SRC)\subnetp.c \
             $(SRC)\subnetd.h $(SRC)\subnetd.c

clean:
    del err*.*
    del $(LIBNAME).lib
    del $(LIBNAME).bak
    del readbgp.obj
    del subnet.obj