; 0930, Fri 16 May 97   Nevil Brownlee
;
; Interface for 'high_performance' pkt driver (spec >= 1.10)
;
;  Usage :
;	    _pktentry
;
;  (c) 1991 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;  version
;
;    0.1    22-May-1992   E. P. Engelke
;
;
        include masmdefs.hsm
        include model.hsm

	cextrn	pkt_rcv_call1		; Nevil, 15 Jul 96
	cextrn	pkt_rcv_call2

codedef ASMPKT
datadef

datastart
ISTACK_SIZE    equ     512     ; (32-bit) double-words
STACK_FILL     equ     0CC33CC33H  ; Stack for AU interrupt handler
       dd      ISTACK_SIZE dup (STACK_FILL)
END_ISTACK_0   equ     $
       dd      ISTACK_SIZE dup (STACK_FILL)
END_ISTACK_1   equ     $
       dd      ISTACK_SIZE dup (STACK_FILL)
END_ISTACK_2   equ     $
       dd      ISTACK_SIZE dup (STACK_FILL)
END_ISTACK_3   equ     $
dataend

cstart  ASMPKT

cproc	_pktentry_h

	public	_pkt_ent_0
_pkt_ent_0:
        pushf			; Preserve int and direction flags
	or	ax,ax		; First or second call?
				; DON'T DO ANYTHING TO CHANGE FLAGS
				; UNTIL THE JNZ SECOND_CALL, BELOW

        cli                     ; Disable interrupts        
        mov     bx,ss           ; Switch to our own stack
        mov     ax,DGROUP
        mov     ss,ax
        mov     ax,sp
	mov	sp,OFFSET DGROUP:END_ISTACK_0
	sti                    ; Enable interrupts

        push    bx             ; Remember caller's ss
        mov	bx,0           ; Interface number
	jmp	short pkt_ent

	public	_pkt_ent_1
_pkt_ent_1:
        pushf			; Preserve int and direction flags
	or	ax,ax		; First or second call?
				; DON'T DO ANYTHING TO CHANGE FLAGS
				; UNTIL THE JNZ SECOND_CALL, BELOW

        cli                     ; Disable interrupts        
        mov     bx,ss           ; Switch to our own stack
        mov     ax,DGROUP
        mov     ss,ax
        mov     ax,sp
	mov	sp,OFFSET DGROUP:END_ISTACK_1
	sti                    ; Enable interrupts

        push    bx             ; Remember caller's ss
        mov	bx,1           ; Interface number
	jmp	short pkt_ent

	public	_pkt_ent_2
_pkt_ent_2:
        pushf			; Preserve int and direction flags
	or	ax,ax		; First or second call?
				; DON'T DO ANYTHING TO CHANGE FLAGS
				; UNTIL THE JNZ SECOND_CALL, BELOW

        cli                     ; Disable interrupts        
        mov     bx,ss           ; Switch to our own stack
        mov     ax,DGROUP
        mov     ss,ax
        mov     ax,sp
	mov	sp,OFFSET DGROUP:END_ISTACK_2
	sti                    ; Enable interrupts

        push    bx             ; Remember caller's ss
        mov	bx,2           ; Interface number
	jmp	short pkt_ent

	public	_pkt_ent_3
_pkt_ent_3:
        pushf			; Preserve int and direction flags
	or	ax,ax		; First or second call?
				; DON'T DO ANYTHING TO CHANGE FLAGS
				;   UNTIL THE JNZ SECOND_CALL, BELOW

        cli                     ; Disable interrupts        
        mov     bx,ss           ; Switch to our own stack
        mov     ax,DGROUP
        mov     ss,ax
        mov     ax,sp
	mov	sp,OFFSET DGROUP:END_ISTACK_3
	sti                    ; Enable interrupts

        push    bx             ; Remember caller's ss
        mov	bx,3           ; Interface number

pkt_ent:
        push    ds              ; Caller's ss, sp and ds have
        pushad	                ;    been saved on our stack

	cld			; Microsoft C needs this, doesn't
				;   harm the flags set by the or ax,ax
				;   above

	jnz	short second_call	; Check result of or ax,ax
					;   way above

        mov     bp,sp
        push	bx		; Interface nbr
	push	ds	        ; Segment part of pkt buffer
	push	si		; Offset part of pkt buffer
	push	dx		; lah_len
	push	cx		; len
        mov     ax,DGROUP
        mov     ds,ax
	ccall	pkt_rcv_call1	; First call returns a far pointer
				; in dx (segment) & ax (offset)

        mov     [bp],ax         ; offset of far ptr returned (via edi)
        mov	es,dx		; segment of far ptr returned
        add     sp,10

help_ret:
        popad                   ; Restore (upper half of) 386 registers
        pop     ds              ; Switch back to caller's stack
        cli                     ; Disable interrupts        
        pop     ss
        mov     sp,ax
        popf			; Restore int and direction flags
	retf

second_call:
	push	bx		; Interface nbr
	push	ds		; Segment part of buffer
	push	si		; Offset part of buffer
	push	cx		; len
        mov     ax,DGROUP
        mov     ds,ax
	ccall	pkt_rcv_call2	; Nothing returned

        add     sp,8
        jmp	short help_ret

cendp   _pktentry_h

cend    ASMPKT
        end
