#include "..\wattcp\copyrigh.h"
#include "..\wattcp\wattcp.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>                     // atoi()

/*
 * Name Domain Service
 *
 * V
 *  0.0 : Jan 11, 1991 : E. Engelke
 */

/*
 * aton()
 *      - converts [a.b.c.d] or a.b.c.d to 32 bit long
 *      - returns 0 on error (safer than -1)
 */

longword aton( text )
char *text;
{
    char *p;
    int i, cur;
    longword ip;

    ip = 0;

    if ( *text == '[' )
        ++text;
    for ( i = 24; i >= 0; i -= 8 ) {
        cur = atoi( text );
        ip |= (longword)(cur & 0xff) << i;
        if (!i) return( ip );

        text = strchr( text, '.');
        if( !text )
            return( 0 );        /* return 0 on error */
        ++text;
    }

    /* shouldn't really get here, this is just
     * to keep the compiler from warning us
     */
    return( 0 );
}

/*
 * isaddr
 *      - returns nonzero if text is simply ip address
 */
word isaddr( text )
char *text;
{
    char ch;

    while( 1 ) {
        ch = *text++;
        if( !ch || ch=='\n' )
            break;

        if ( isdigit(ch) ) continue;
        if ( ch == '.' || ch == ' ' || ch == '[' || ch == ']' )
            continue;

        return( 0 );
    }
    return( 1 );
}

char *inet_ntoa( char *s, longword x )
{

    itoa( x >> 24, s, 10 );
    strcat( s, ".");
    itoa( (x >> 16) & 0xff, strchr( s, 0), 10);
    strcat( s, ".");
    itoa( (x >> 8) & 0xff, strchr( s, 0), 10);
    strcat( s, ".");
    itoa( (x) & 0xff, strchr( s, 0), 10);
    return( s );
}

longword inet_addr( char *s )
{
    return( isaddr( s ) ? aton( s ) : 0 );
}

